#ifndef RUNNERAGENT_HH
#define RUNNERAGENT_HH

//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.01
// * made minimax functions class members
 
//----------------------------------------------------------------------------

#include "Agent.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

void Dijkstra(Point_2D, BlockMaze *);

//----------------------------------------------------------------------------

class RunnerAgent : public Agent
{
public:

  RunnerAgent(string s, char c, int i, int x = 0, int y = 0) : Agent(s, c, i, x, y) { }
  ~RunnerAgent() { }

  void update(const GameState &, BlockMaze *);

  // minimax-related functions and variables

  bool minimax_value(bool, int, const GameState &, BlockMaze *, float &, Point_2D &);
  float eval(const GameState &, BlockMaze *);
  bool cutoff_test(int, const GameState &, BlockMaze *);
  bool terminal_state(float &, const GameState &, BlockMaze *);

  void update_best_minimax_move(bool, int, int, int, int, const GameState &, BlockMaze *, float &, Point_2D &);

  float best_minimax_value;               // where the value of the game state is filled in
  Point_2D best_minimax_move;             // where the move to make (if there is one) is filled in

};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
